/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: CStdio.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#ifndef OpenSOAP_CStdio_H
#define OpenSOAP_CStdio_H

#include <OpenSOAP/ByteArray.h>

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
    
    typedef struct tagOpenSOAPCStdio OpenSOAPCStdio;
    typedef OpenSOAPCStdio    *OpenSOAPCStdioPtr;
    
    int
    OPENSOAP_API
    OpenSOAPCStdioCreate(/* [out] */ OpenSOAPCStdioPtr *s);
    
    int
    OPENSOAP_API
    OpenSOAPCStdioCreateWithFILEPtr(/* [in]  */ FILE *is,
                                    /* [in]  */ FILE *os,
                                    /* [out] */ OpenSOAPCStdioPtr *s);
    
    int
    OPENSOAP_API
    OpenSOAPCStdioCreateForStdio(/* [out] */ OpenSOAPCStdioPtr *s);
    
    int
    OPENSOAP_API
    OpenSOAPCStdioClose(/* [in] */ OpenSOAPCStdioPtr s);

    int
    OPENSOAP_API
    OpenSOAPCStdioRelease(/* [in] */ OpenSOAPCStdioPtr s);

    int
    OPENSOAP_API
    OpenSOAPCStdioSetBinaryMode(/* [in] */ OpenSOAPCStdioPtr s);
    
    int
    OPENSOAP_API
    OpenSOAPCStdioSetTextMode(/* [in] */ OpenSOAPCStdioPtr s);

    int
    OPENSOAP_API
    OpenSOAPCStdioRead(/* [in]      */ OpenSOAPCStdioPtr s,
                       /* [out]     */ unsigned char *buf,
                       /* [in, out] */ size_t *buf_sz);
    
    int
    OPENSOAP_API
    OpenSOAPCStdioWrite(/* [in]      */ OpenSOAPCStdioPtr s,
                        /* [in]      */ const unsigned char *buf,
                        /* [in, out] */ size_t *buf_sz);

    int
    OPENSOAP_API
    OpenSOAPCStdioReadToDelm(/* [in]  */ OpenSOAPCStdioPtr s,
                             /* [in]  */ const unsigned char *delm,
                             /* [in]  */ size_t delm_sz,
                             /* [out] */ OpenSOAPByteArrayPtr buf);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_CStdio_H */
