# -----------------------------------------------------------------------------
#   $RCSfile: CalcAsyncPath.mak,v $
#  
#   See Copyright for the status of this software.
#  
#   The OpenSOAP Project
#   http://opensoap.jp/
# -----------------------------------------------------------------------------

PROGRAMS = CalcClient

OPENSOAP_PREFIX=/usr/local
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

CFLAGS= -I$(OPENSOAP_INCLUDE)
# CFLAGS=-g -I$(OPENSOAP_INCLUDE)
CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE_CGI
CLIENT_CGI_CFLAGS=$(CFLAGS) -DCLIENT_CGI
CLIENT_LDFLAGS=-Wl,-rpath -Wl,$(OPENSOAP_LIB) -lOpenSOAPClient
SERVICE_LDFLAGS=$(CLIENT_LDFLAGS) -lOpenSOAPService

SOURCES = CalcClient.c 
OBJS=$(SOURCES:.c=.o) 


all: $(PROGRAMS)


## Make Client Programs

CalcClient: CalcClient.o
	$(CC) -o $@ $^ $(CLIENT_LDFLAGS)

## Install Client Programs

install: $(PROGRAMS)
	cp CalcService /usr/local/sbin/

clean: 
	rm -f $(OBJS) $(PROGRAMS)


## Test Client-Server-Service Hookups for Sync/Async Success Cases

cstest1:
	./CalcClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP Add 10 20
cstest1a:
	./CalcClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP AddAsync 10 20 > tmp_msg

cstest2:
	./CalcClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP Subtract 10 20
cstest2a:
	./CalcClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP SubtractAsync 10 20 > tmp_msg

cstest3:
	./CalcClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP Multiply 10 20
cstest3a:
	./CalcClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP MultiplyAsync 10 20 > tmp_msg

cstest4:
	./CalcClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP Divide 10 20
cstest4a:
	./CalcClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP DivideAsync 10 20 > tmp_msg

cstestr:
	cat tmp_msg | ./CalcClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP GetResult
