# -----------------------------------------------------------------------------
#  $RCSfile: HelloSec.mak,v $
# 
#  See Copyright for the status of this software.
# 
#  The OpenSOAP Project
#  http://opensoap.jp/
# -----------------------------------------------------------------------------

#
prefix=/usr/local
bindir=$(prefix)/bin
sbindir=$(prefix)/sbin
#sysconfdir=$(prefix)/etc
#localstatedir=$(prefix)/var
CGI_BIN_DIR=/home/httpd/cgi-bin
#CGI_BIN_DIR=/var/www/cgi-bin
#CGI_BIN_DIR=/usr/local/apache2/cgi-bin
#CGI_BIN_DIR=/usr/lib/cgi-bin
#
INSTALL_PROGRAM=install -c
# 
OPENSOAP_PREFIX=$(prefix)
OPENSOAP_SYSCONFDIR=/var/tmp/OpenSOAP
OPENSOAP_LOCALSTATEDIR=/var/tmp/OpenSOAP
SSMLDIR=$(OPENSOAP_SYSCONFDIR)/conf/ssml

# use libiconv
#ICONV_LIBS=-liconv

#
console_client_PROGRAMFILES = HelloSecClient
#
cgi_client_PROGRAMFILES = 
CLIENT_HTML_DIR = 
CLIENT_HTML_FILES = 

cgi_client_USEKEYFILES = \
	 	pubKey_HelloService.pem \
		privKey_HelloClient.pem

#
cgi_service_PROGRAMFILES = HelloSecService.cgi

#
service_USEKEYFILES = \
	 	privKey_HelloService.pem \
		pubKey_HelloClient.pem

servicerootdir=/var/tmp/Hello
servicekeysdir=$(servicerootdir)/keys

#
stdio_service_PROGRAMFILES = HelloSecService
SSML_FILES = HelloSec.ssml

#
PROGRAMS = \
	$(console_client_PROGRAMFILES) \
	$(stdio_service_PROGRAMFILES) \
	$(cgi_service_PROGRAMFILES)

XML2_LIBS=`xml2-config --libs`

COMMON_LIBS=$(XML2_LIBS) $(ICONV_LIBS) -lcrypto

#
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

#
CFLAGS=-I$(OPENSOAP_INCLUDE)
#CFLAGS=-Wall -I$(OPENSOAP_INCLUDE)
CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE=\"cgi\"

COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -R$(OPENSOAP_LIB)
CLIENT_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPSecurity -lOpenSOAPClient $(COMMON_LIBS)
SERVICE_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPService -lOpenSOAPSecurity -lOpenSOAPClient $(COMMON_LIBS)

SOURCES = HelloSecClient.c HelloSecService.c
OBJS=$(SOURCES:.c=.o) HelloSecService.cgi.o

all: $(PROGRAMS)

## Make Client Programs

HelloSecClient: HelloSecClient.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS)

## Make Service Programs

HelloSecService.cgi.o: HelloSecService.c
	$(CC) $(CGI_CFLAGS) -c -o $@ $<

HelloSecService: HelloSecService.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

HelloSecService.cgi: HelloSecService.cgi.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

## Install Programs

#
console-client-install: $(console_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(bindir); then \
		echo "$(DESTDIR)$(bindir) exits."; \
	else \
		echo "$(DESTDIR)$(bindir) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(bindir)."; \
		mkdir -p $(DESTDIR)$(bindir); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(bindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(bindir); \
	done

cgi-client-programs-install: $(cgi_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exits."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR); \
	done

cgi-client-datas-install: $(CLIENT_HTML_FILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exits."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	cp -r $(CLIENT_HTML_DIR) $(DESTDIR)$(CGI_BIN_DIR)

cgi-client-install: cgi-client-programs-install cgi-client-datas-install
#
client-install: console-client-install cgi-client-install

service-usekeys-install: $(service_USEKEYFILES)
	@if test -d $(DESTDIR)$(servicekeysdir); then \
		echo "$(DESTDIR)$(servicekeysdir) exist."; \
	else \
		echo "mkdir -p $(DESTDIR)$(servicekeysdir)."; \
		mkdir -p $(DESTDIR)$(servicekeysdir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(servicekeysdir)."; \
		$(INSTALL_PROGRAM) \
			-m 0644 \
			$$f $(DESTDIR)$(servicekeysdir); \
	done

#
ssml-install: $(SSML_FILES)
	@if test -d $(DESTDIR)$(SSMLDIR); then \
		echo "$(DESTDIR)$(SSMLDIR) exits."; \
	else \
		echo "mkdir -p $(DESTDIR)$(SSMLDIR)."; \
		mkdir -p $(DESTDIR)$(SSMLDIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(SSMLDIR)."; \
		cp $$f $(DESTDIR)$(SSMLDIR); \
	done

stdio-service-programs-install: $(stdio_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(sbindir); then \
		echo "$(DESTDIR)$(sbindir) exits."; \
	else \
		echo "$(DESTDIR)$(sbindir) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(sbindir)."; \
		mkdir -p $(DESTDIR)$(sbindir); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(sbindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(sbindir); \
	done

stdio-service-install: service-usekeys-install stdio-service-programs-install ssml-install

#
cgi-service-install: $(cgi_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exits."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR); \
	done

service-install: service-usekeys-install cgi-service-install stdio-service-install ssml-install

#
sample-install: client-install service-install

## Install Service Programs
install: service-install

## clean objects and programs
clean: 
	rm -f $(OBJS) $(PROGRAMS)


## Test Service Alone

stest: $(stdio_service_PROGRAMFILES)
	cat hello_sec_request.xml | ./HelloSecService.cgi

## Test Client-Service Hookups

ctest: $(console_client_PROGRAMFILES)
	./HelloSecClient foo "http://localhost/cgi-bin/HelloSecService.cgi"

## Test Client-Server-Service Hookups

cstest: $(console_client_PROGRAMFILES)
	./HelloSecClient foo http://localhost/cgi-bin/soapInterface.cgi

