/*-----------------------------------------------------------------------------
 * $RCSfile: DBrefer.c,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#include <stdio.h>
#include <string.h>
#include <OpenSOAP/Security.h>

#define CA_DATABASE_FILE "/var/tmp/OpenSOAP/Data/Security/CA.db" /* F؋DBt@Cւ̃pX */
#define CA_DATABASE_ENV  "OPENSOAP_CA_DATABASE" /* F؋DB`ϐ */
#define CA_PRIVKEY_FILE   "/var/tmp/OpenSOAP/Data/Security/privKey.pem"  /* F؋ǂ̔閧t@C */
#define CA_PUBLISHER_NAME "OpenSOAP-SAMPLE-CA"  /* F؋ǂ̖ */

#ifdef _MSC_VER
#define snprintf _snprintf
#endif /* _MSC_VER */

/***************************************************************************** 
    Function      : gp@̕\
    Return        : void
 ************************************************ Yuji Yamawaki 02.03.14 *****/
static void usage
(const char* szProg)
{
    fprintf(stderr, "Usage: %s OwnerName CertFileName\n", szProg);
}
/***************************************************************************** 
    Function      : main
    Return        : int(0: No Error, 1: NG[ 2: sG[)
 ************************************************ Yuji Yamawaki 02.03.14 *****/
int main(int argc, char* argv[])
{
    int nRet = 0;
    int nLibRet;
    char szBuf[256];
    OpenSOAPCARecPtr pRec = NULL;
    if (argc < 3) {
        usage(argv[0]);
        return 1;
    }
    /* F؋DBt@C̐ݒ */
    snprintf(szBuf, sizeof(szBuf), "%s=%s", CA_DATABASE_ENV, CA_DATABASE_FILE);
    if (putenv(szBuf) != 0) {
        return 2;
    }
    /* ̂烌R[h */
    nLibRet = OpenSOAPSecCASearchOneRecord(argv[1], &pRec);
    if (OPENSOAP_FAILED(nLibRet)) {
        nRet = 2;
        goto FuncEnd;
    }
    /* R[hؖ쐬 */
    nLibRet = OpenSOAPSecCertCreateWithFile(CA_PUBLISHER_NAME,
                                            CA_PRIVKEY_FILE,
                                            OPENSOAP_HA_SHA,
                                            pRec,
                                            argv[2]);
    if (OPENSOAP_FAILED(nLibRet)) {
        nRet = 2;
        goto FuncEnd;
    }
FuncEnd:
    if (pRec != NULL) {
        OpenSOAPSecCAFreeRecord(pRec);
    }
    return nRet;
}
