# -----------------------------------------------------------------------------
#  $RCSfile: GetCert.mak,v $
# 
#  See Copyright for the status of this software.
# 
#  The OpenSOAP Project
#  http://opensoap.jp/
# -----------------------------------------------------------------------------
prefix=/usr/local
bindir=$(prefix)/bin
sbindir=$(prefix)/sbin
#sysconfdir=$(prefix)/etc
#localstatedir=$(prefix)/var
CGI_BIN_DIR=/home/httpd/cgi-bin
#CGI_BIN_DIR=/var/www/cgi-bin
#CGI_BIN_DIR=/usr/local/apache2/cgi-bin
#CGI_BIN_DIR=/usr/lib/cgi-bin
#
INSTALL = install -c
INSTALL_PROGRAM = $(INSTALL)
INSTALL_DATA = $(INSTALL) -m 644
INSTALL_SCRIPT = $(INSTALL_PROGRAM)
# 
OPENSOAP_PREFIX=$(prefix)
OPENSOAP_SYSCONFDIR=/var/tmp/OpenSOAP
OPENSOAP_LOCALSTATEDIR=/var/tmp/OpenSOAP
SSML_DIR=$(OPENSOAP_SYSCONFDIR)/conf/ssml

# use libiconv
#ICONV_LIBS=-liconv

#
console_client_PROGRAMFILES =  GetCertClient 
#
service_support_PROGRAMFILES = CA_Refer
service_support_PROGRAMFILES_MODE = 4755
#
cgi_service_PROGRAMFILES = GetCertService.cgi

#
servicedatadir=$(OPENSOAP_LOCALSTATEDIR)/Data/Security
service_DATAFILES = \
			CA.db \
			CA.db_sno

service_DATAFILES_MODE = 0666

#
stdio_service_PROGRAMFILES = GetCertService
SSML_FILES = GetCert.ssml

#
PROGRAMS = \
	$(console_client_PROGRAMFILES) \
	$(service_support_PROGRAMFILES) \
	$(stdio_service_PROGRAMFILES) \
	$(cgi_service_PROGRAMFILES)

XML2_LIBS=`xml2-config --libs`

COMMON_LIBS=$(XML2_LIBS) $(ICONV_LIBS) -lcrypto
#
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

#
CFLAGS= -I$(OPENSOAP_INCLUDE)
# CFLAGS=-g -I$(OPENSOAP_INCLUDE)
CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE=\"cgi\"

COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -R$(OPENSOAP_LIB)
CLIENT_LDFLAGS=$(COMMON_LDFLAGS) \
		-lOpenSOAPClient -lOpenSOAPSecurity $(COMMON_LIBS)
SERVICE_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPService \
		-lOpenSOAPSecurity -lOpenSOAPClient $(COMMON_LIBS)

#
SOURCES = \
	GetCertClient.c \
	GetCertService.c \
	DBrefer.c

OBJS=$(SOURCES:.c=.o) GetCertService.cgi.o

all: $(PROGRAMS)

## Make Client Programs

GetCertClient: GetCertClient.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS)

## Make Service Programs

## Service support program
CA_Refer: DBrefer.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS)

GetCertService: GetCertService.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

GetCertService.cgi: GetCertService.cgi.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

GetCertService.cgi.o: GetCertService.c
	$(CC) $(CGI_CFLAGS) -c -o $@ $<


## Install Client Programs

#
console-client-install: $(console_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(bindir); then \
		echo "$(DESTDIR)$(bindir) exist."; \
	else \
		echo "$(DESTDIR)$(bindir) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(bindir)."; \
		mkdir -p $(DESTDIR)$(bindir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(bindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(bindir)/$$f; \
	done
#
client-install: console-client-install

## Install Service Programs

#
service-support-install: $(service_support_PROGRAMFILES)
	@if test -d $(DESTDIR)$(sbindir); then \
		echo "$(DESTDIR)$(sbindir) exist."; \
	else \
		echo "$(DESTDIR)$(sbindir) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(sbindir)."; \
		mkdir -p $(DESTDIR)$(sbindir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(sbindir)."; \
		$(INSTALL) -m $(service_support_PROGRAMFILES_MODE) \
			$$f $(DESTDIR)$(sbindir); \
	done


#
service-datas-install: $(service_DATAFILES)
	@if test -d $(DESTDIR)$(servicedatadir); then \
		echo "$(DESTDIR)$(servicedatadir) exist."; \
	else \
		echo "mkdir -p $(DESTDIR)$(servicedatadir)."; \
		mkdir -p $(DESTDIR)$(servicedatadir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(servicedatadir)."; \
		$(INSTALL) -m $(service_DATAFILES_MODE) \
			$$f $(DESTDIR)$(servicedatadir)/$$f; \
	done

service-common-install: service-support-install service-datas-install

#
ssml-install: $(SSML_FILES)
	@if test -d $(DESTDIR)$(SSML_DIR); then \
		echo "$(DESTDIR)$(SSML_DIR) exist."; \
	else \
		echo "mkdir -p $(DESTDIR)$(SSML_DIR)."; \
		mkdir -p $(DESTDIR)$(SSML_DIR); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(SSML_DIR)."; \
		$(INSTALL_DATA) \
			$$f $(DESTDIR)$(SSML_DIR)/$$f; \
	done

stdio-service-programs-install: $(stdio_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(sbindir); then \
		echo "$(DESTDIR)$(sbindir) exist."; \
	else \
		echo "$(DESTDIR)$(sbindir) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(sbindir)."; \
		mkdir -p $(DESTDIR)$(sbindir); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(sbindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(sbindir); \
	done

stdio-service-install: \
	service-common-install \
	stdio-service-programs-install \
	ssml-install

#
cgi-service-programs-install: $(cgi_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exist."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR)/$$f; \
	done

cgi-service-install: \
	service-common-install \
	cgi-service-programs-install

#
service-install: cgi-service-install stdio-service-install

#
sample-install: client-install service-install

# 
install: service-install

## 

clean: 
	rm -f $(OBJS) $(PROGRAMS) *~ core pubKey_res.pem result.cert


## Test Client-Service (or Client-Server-Service) Hookups

ctest:
	./GetCertClient "David Beckham"

