# -----------------------------------------------------------------------------
#  $RCSfile: SimpleCalc.mak,v $
# 
#  See Copyright for the status of this software.
# 
#  The OpenSOAP Project
#  http://opensoap.jp/
# -----------------------------------------------------------------------------

#
prefix=/usr/local
bindir=$(prefix)/bin
sbindir=$(prefix)/sbin
#sysconfdir=$(prefix)/etc
#localstatedir=$(prefix)/var
CGI_BIN_DIR=/home/httpd/cgi-bin
#CGI_BIN_DIR=/var/www/cgi-bin
#CGI_BIN_DIR=/usr/local/apache2/cgi-bin
#CGI_BIN_DIR=/usr/lib/cgi-bin
#
INSTALL_PROGRAM=install -c
# 
OPENSOAP_PREFIX=$(prefix)
OPENSOAP_SYSCONFDIR=/var/tmp/OpenSOAP
OPENSOAP_LOCALSTATEDIR=/var/tmp/OpenSOAP
SSMLDIR=$(OPENSOAP_SYSCONFDIR)/conf/ssml

# use libiconv
#ICONV_LIBS=-liconv

#
console_client_PROGRAMFILES = SimpleCalcClient
#
cgi_client_PROGRAMFILES = 
CLIENT_HTML_DIR = 
CLIENT_HTML_FILES = 
#
cgi_service_PROGRAMFILES = SimpleCalcService.cgi
#
stdio_service_PROGRAMFILES = SimpleCalcService
SSML_FILES = SimpleCalc.ssml

#
PROGRAMS = \
	$(console_client_PROGRAMFILES) \
	$(stdio_service_PROGRAMFILES) \
	$(cgi_service_PROGRAMFILES)

XML2_LIBS=`xml2-config --libs`

COMMON_LIBS=$(XML2_LIBS) $(ICONV_LIBS)

#
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

#
CFLAGS=-I$(OPENSOAP_INCLUDE)
CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE=\"cgi\"
COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -R$(OPENSOAP_LIB)
CLIENT_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPClient $(COMMON_LIBS)
SERVICE_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPService -lOpenSOAPClient $(COMMON_LIBS)

SOURCES = SimpleCalcClient.c SimpleCalcService.c
OBJS=$(SOURCES:.c=.o) SimpleCalcService.cgi.o

all: $(PROGRAMS)

## Make Client Programs

SimpleCalcClient: SimpleCalcClient.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS)

## Make Service Programs

SimpleCalcService.cgi.o: SimpleCalcService.c
	$(CC) $(CGI_CFLAGS) -c -o $@ $<

SimpleCalcService: SimpleCalcService.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

SimpleCalcService.cgi: SimpleCalcService.cgi.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

## Install Programs

#
console-client-install: $(console_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(bindir); then \
		echo "$(DESTDIR)$(bindir) exits."; \
	else \
		echo "$(DESTDIR)$(bindir) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(bindir)."; \
		mkdir -p $(DESTDIR)$(bindir); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(bindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(bindir); \
	done

cgi-client-programs-install: $(cgi_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exits."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR); \
	done

cgi-client-datas-install: $(CLIENT_HTML_FILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exits."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	cp -r $(CLIENT_HTML_DIR) $(DESTDIR)$(CGI_BIN_DIR)

cgi-client-install: cgi-client-programs-install cgi-client-datas-install
#
client-install: console-client-install cgi-client-install

#
ssml-install: $(SSML_FILES)
	@if test -d $(DESTDIR)$(SSMLDIR); then \
		echo "$(DESTDIR)$(SSMLDIR) exits."; \
	else \
		echo "mkdir -p $(DESTDIR)$(SSMLDIR)."; \
		mkdir -p $(DESTDIR)$(SSMLDIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(SSMLDIR)."; \
		cp $$f $(DESTDIR)$(SSMLDIR); \
	done

stdio-service-programs-install: $(stdio_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(sbindir); then \
		echo "$(DESTDIR)$(sbindir) exits."; \
	else \
		echo "$(DESTDIR)$(sbindir) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(sbindir)."; \
		mkdir -p $(DESTDIR)$(sbindir); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(sbindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(sbindir); \
	done

stdio-service-install: stdio-service-programs-install ssml-install

#
cgi-service-install: $(cgi_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exits."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR); \
	done

service-install: cgi-service-install stdio-service-install ssml-install

#
sample-install: client-install service-install

## Install Service Programs
install: service-install

## clean objects and programs
clean: 
	rm -f $(OBJS) $(PROGRAMS)


## Test Service Programs

stest1: $(stdio_service_PROGRAMFILES)
	cat SimpleCalcSampleMessages/add_request.xml | ./SimpleCalcService.cgi
stest2: $(stdio_service_PROGRAMFILES)
	cat SimpleCalcSampleMessages/subtract_request.xml | ./SimpleCalcService.cgi
stest3: $(stdio_service_PROGRAMFILES)
	cat SimpleCalcSampleMessages/multiply_request.xml | ./SimpleCalcService.cgi
stest4: $(stdio_service_PROGRAMFILES)
	cat SimpleCalcSampleMessages/divide_request.xml | ./SimpleCalcService.cgi

## Test Client-Service Hookups

ctest1: $(console_client_PROGRAMFILES)
	./SimpleCalcClient Add 10.0 20.0 http://localhost/cgi-bin/SimpleCalcService.cgi
ctest2: $(console_client_PROGRAMFILES)
	./SimpleCalcClient Subtract 10.0 20.0 http://localhost/cgi-bin/SimpleCalcService.cgi
ctest3: $(console_client_PROGRAMFILES)
	./SimpleCalcClient Multiply 10.0 20.0 http://localhost/cgi-bin/SimpleCalcService.cgi
ctest4: $(console_client_PROGRAMFILES)
	./SimpleCalcClient Divide 10.0 20.0 http://localhost/cgi-bin/SimpleCalcService.cgi

## Test Client-Server-Service Hookups

cstest1: $(console_client_PROGRAMFILES)
	./SimpleCalcClient Add 10.0 20.0 http://localhost/cgi-bin/soapInterface.cgi
cstest2: $(console_client_PROGRAMFILES)
	./SimpleCalcClient Subtract 10.0 20.0 http://localhost/cgi-bin/soapInterface.cgi
cstest3: $(console_client_PROGRAMFILES)
	./SimpleCalcClient Multiply 10.0 20.0 http://localhost/cgi-bin/soapInterface.cgi
cstest4: $(console_client_PROGRAMFILES)
	./SimpleCalcClient Divide 10.0 20.0 http://localhost/cgi-bin/soapInterface.cgi
