/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: DataRetainer.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef DataRetainer_H
#define DataRetainer_H

#include <string>
#include <map>

#include "Defines.h"

namespace OpenSOAP {

  class DataContainer;
  
  class DataRetainer {

  public:
    //--- Id class ---
    //IDNX
    //͕
    class Id {
    public:
	OPENSOAP_VAR
      Id() {}
	OPENSOAP_VAR
      Id(const std::string& id) : id_(id) {}
	OPENSOAP_VAR
      ~Id() {}
      
	OPENSOAP_VAR
      const std::string toString() const { return id_; }
	OPENSOAP_VAR
      bool fromString(const std::string& id) { id_ = id; return isValid(); }

	OPENSOAP_VAR
      bool isValid() const { return (id_.empty() || INVALID == id_) ?
			       false : true; }
      
      static const std::string INVALID; // = "<invalid>"

    protected:
      std::string id_;
    };
    //--- End Id class ---

    //typedef std::string Id;

    //static const std::string ID_NONE; // = "<none>"

  public:
    //DataRetainer();
	OPENSOAP_VAR
    DataRetainer(const std::string& saveDir);
	OPENSOAP_VAR
    DataRetainer(const std::map<int, std::string>& attr);
	OPENSOAP_VAR
    virtual ~DataRetainer();

    enum ATTR_TYPE {
      SAVE_DIR = 1,
      ID_PREFIX,
    };

    //Kvȑ̐ݒ
    //(P)FileRetaineȑꍇ͕ێfBNgpX
    //(Q)DBRetaineȑꍇDB[UID,DBpX[h,e[u
    //(R)SHMRetainer̋LZOgL[,LTCY
    //virtual int setAttributes(const std::vector<string>& attr);
	OPENSOAP_VAR
    virtual int setAttributes(const std::map<int, std::string>& attr);

    //    virtual int write(DataContainer& dataCont);
    //    virtual int read(DataContainer& dataCont);
    //f[^ۑ
	OPENSOAP_VAR
    virtual int put(DataContainer& dataCont);
    //f[^㏑
	OPENSOAP_VAR
    virtual int update(DataContainer& dataCont);
    //f[^ǂݏo
	OPENSOAP_VAR
    virtual int get(DataContainer& dataCont);
    //f[^폜
	OPENSOAP_VAR
    virtual int del(const Id& id);
    //f[^ǂݏo폜
	OPENSOAP_VAR
    virtual int delget(DataContainer& dataCont);
    //f[^݃`FbN
	OPENSOAP_VAR
    virtual bool exists(const Id& id);
    
  protected:
    //̎_ł̃VXeԂt@CƂID擾
    const Id getNewId();
	
#if 0
  //b܂łƂPbȓɕ̏ꍇɏd邽
  //̂ƂɂT̃V[PXԍtB
  //V[PXԍIDsɃJEgAbv99999ȏłOɖ߂B
#endif
    
    std::map<int, std::string> attributes_;
    std::string saveDir_;

  };

  class DataContainer {
  public:
	OPENSOAP_VAR
    DataContainer() {}
	OPENSOAP_VAR
    DataContainer(const DataRetainer::Id& id) : id_(id) {}
	OPENSOAP_VAR
    DataContainer(const std::string& data) : data_(data) {}
	OPENSOAP_VAR
    virtual ~DataContainer() {}
    
	OPENSOAP_VAR
    const DataRetainer::Id& getId() const { return id_; }
#if defined(WIN32)
	OPENSOAP_VAR
    const std::string getData() const { return data_; }
#else
    const std::string& getData() const { return data_; }
#endif

	OPENSOAP_VAR
    void setId(const DataRetainer::Id& id) { id_ = id; }
	OPENSOAP_VAR
    void setData(const std::string& data) { data_ = data; }

  protected:
    DataRetainer::Id id_;
    std::string data_;
  };


} // end of namespace OpenSOAP


#endif /* DataRetainer_H */
