/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: FIFODescriptor.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include "FIFODescriptor.h"

using namespace OpenSOAP;


const std::string TAG_ERR = "*** E ***::";

//==== FIFIODescriptor ====
//FIFOւ̃t@CfBXNv^NX


FIFODescriptor::FIFODescriptor()
  : readFIFO_(-1)
  , writeFIFO_(-1)
{
#ifdef DEBUG
  cerr << "FIFODescriptor::FIFODescriptor()" << endl;
#endif
}

FIFODescriptor::FIFODescriptor(const std::string& id)
  : id_(id)
  , readFIFO_(-1)
  , writeFIFO_(-1)
{
#ifdef DEBUG
  cerr << "FIFODescriptor::FIFODescriptor(" << id << ")" << endl;
#endif
}


FIFODescriptor::~FIFODescriptor()
{
#ifdef DEBUG
  cerr << "FIFODescriptor::~FIFODescriptor()" << endl;
#endif
}

int FIFODescriptor::getReadFIFO() const
{
  return readFIFO_;
}

int FIFODescriptor::getWriteFIFO() const
{
  return writeFIFO_;
}


void FIFODescriptor::setId(const std::string& id)
{
  id_ = id;
}

void FIFODescriptor::setReadFIFO(const int fd)
{
  readFIFO_ = fd;
}

void FIFODescriptor::setWriteFIFO(const int fd)
{
  writeFIFO_ = fd;
}

// End of FIFODescriptor.cpp
